package com.edufound.mobile.Util;

import android.content.Intent;
import android.support.annotation.Nullable;
import android.util.Log;
import android.widget.Toast;

import com.edufound.mobile.activity.WebActivity;
import com.facebook.react.bridge.Arguments;
import com.facebook.react.bridge.ReactApplicationContext;
import com.facebook.react.bridge.ReactContext;
import com.facebook.react.bridge.ReactContextBaseJavaModule;
import com.facebook.react.bridge.ReactMethod;
import com.facebook.react.bridge.WritableMap;
import com.facebook.react.modules.core.DeviceEventManagerModule;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class AndroidUtil extends ReactContextBaseJavaModule {

    private static final String DURATION_SHORT_KEY = "SHORT";
    private static final String DURATION_LONG_KEY = "LONG";
    private static final String CLASS_NAME = "AndroidUtil";
    public static ReactContext mContext;

    public AndroidUtil(ReactApplicationContext reactContext) {
        super(reactContext);
        mContext = reactContext;
        this.initialize();
    }

    @Override
    public String getName() {
        return CLASS_NAME;
    }

    @Override
    public Map<String, Object> getConstants() {
        final Map<String, Object> constants = new HashMap<>();
        constants.put(DURATION_SHORT_KEY, Toast.LENGTH_SHORT);
        constants.put(DURATION_LONG_KEY, Toast.LENGTH_LONG);
        return constants;
    }

    @ReactMethod
    public void showToast(String message, int duration) {
        Toast.makeText(getReactApplicationContext(), message, duration).show();
    }

    @ReactMethod
    public void toWebActivity(String Json) {
        Intent intent = new Intent(getReactApplicationContext(), WebActivity.class);
        intent.putExtra("json", Json);
        intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
        getReactApplicationContext().startActivity(intent);
    }

    @ReactMethod
    public void testJS() {
        WritableMap event = Arguments.createMap();
        //传递的参数
        event.putString("ceshi", "132456456");
        //EventName为JS监听的事件
        sendEvent(mContext, "testJSaaa", event);

    }

    @ReactMethod
    public static void callBackJS(Map<String, String> map, String name) {
        WritableMap event = Arguments.createMap();
        //传递的参数
        Set<Map.Entry<String, String>> set = map.entrySet();
        if (map != null && map.size() > 0) {
            for (Map.Entry<String, String> me : set) {
                // 根据键值对对象获取键和值
                String key = me.getKey();
                String value = me.getValue();
                event.putString(key, value);
            }
        }
        //EventName为JS监听的事件
        sendEvent(mContext, name, event);
    }

    private static void sendEvent(ReactContext reactContext, String eventName, @Nullable WritableMap params) {
        if (reactContext == null) {
            return;
        }
        reactContext.getJSModule(DeviceEventManagerModule.RCTDeviceEventEmitter.class).emit(eventName, params);
    }


}
