import React, { Component } from "react";
import {
  Platform,
  StyleSheet,
  Text,
  View,
  Image,
  TouchableOpacity,
  ImageBackground,
  Button,
  Dimensions,
  DeviceEventEmitter
} from "react-native";

/** 因没有图，所以Image先用颜色代替，有图可替换 */
const instructions = Platform.select({
  ios: "Press Cmd+R to reload,\n" + "Cmd+D or shake for dev menu",
  android:
    "Double tap R on your keyboard to reload,\n" +
    "Shake or press menu button for dev menu"
});

type Props = {};
var width = Dimensions.get("window").width;
var height = Dimensions.get("window").height;
export default class CourseTitle extends Component<Props> {
  render() {
    return (
      <View
        style={{
          backgroundColor: "withe",
          width: this.props.width,
          height: this.props.height,
          flexDirection: "column"
        }}
      >
        <View
          style={{
            flex: 1
          }}
        />
        <View
          style={{
            flex: 1,
            flexDirection: "row"
          }}
        >
          <View
            style={{
              flex: 1,
              alignItems: "center",
              justifyContent: "center"
            }}
          >
            <TouchableOpacity
              //返回
              activeOpacity={1}
              onPress={this.props.backPress}
            >
              <Image
                style={{ width: 20, height: 20, backgroundColor: "blue" }}
              />
            </TouchableOpacity>
          </View>
          <View style={{ flex: 5 }}>
            <Text
              style={{
                width: "100%",
                fontSize: 18,
                fontWeight: "bold",
                textAlign: "center"
              }}
            >
              {this.props.title}
            </Text>
          </View>
          <View style={{ flex: 1 }}>
            <TouchableOpacity
              //分享
              activeOpacity={1}
              onPress={this.props.sharedpress}
            >
              <Image
                style={{ width: 20, height: 20, backgroundColor: "blue" }}
              />
            </TouchableOpacity>
          </View>
        </View>
        <View
          style={{
            flex: 1
          }}
        />
      </View>
    );
  }
}
/**

      使用方法
    <CourseTitle
          width={150}
          height={50}
          title="学前"
          backPress={() => this.goBack()}
          sharedpress={() => alert("点击分享")}
        />

 */
